package com.sagacloud.util.compute_engine.core;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.util.StepSpan;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CoreOutput {
    // 编号
    public String output_sign;
    public Date time_begin;
    public Date time_end;
    // near,consumption
    public String data_class;
    // 传递给dao_data的标记
    public String dao_type;
    public JSONObject dao_key;
    // 默认有一个输入数据就计算，true表示所有输入数据齐活了才算
    public boolean need_all_var_data = false;
    // 是否已经初始化
    public boolean time_period_intialized = false;
    // 未初始化，则根据mode和输入自动设置的字段
    public String time_period;
    // expression,custom
    public String mode;
    // 公式
    public String expression;
    //
    public String custom_function_name;
    //
    public Map<String, String> custom_paramsMap = new HashMap<String, String>();

    // 语法树
    public GrammarTreeNode root;
    public Map<String, Boolean> var_originalMap = new HashMap<String, Boolean>();
    public Map<String, Boolean> var_signMap = new HashMap<String, Boolean>();
    public Map<String, StepSpan> var_stepSpanMap = new HashMap<String, StepSpan>();
    public Map<String, Boolean> other_paramMap = new HashMap<String, Boolean>();

    // 其他
    public String other_type;
    public Map<String, Object> otherMap;

    // network
    public List<Object> predecessorList;
    public List<CoreOutput> successorList;
    public Map<String, Boolean> all_input;
}
