package com.sagacloud.util.compute_engine.util;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class DateUtil {
    private static final DateUtil instance = new DateUtil();

    private DateUtil() {

    }

    public static DateUtil Instance() {
        return instance;
    }

    public static void main(String[] args) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        List<TimeSpan> timeSpanList_1 = new ArrayList<TimeSpan>();
        timeSpanList_1.add(new TimeSpan(sdf.parse("2017-01-01 02:00:00"), sdf.parse("2017-01-01 03:00:00")));
        timeSpanList_1.add(new TimeSpan(sdf.parse("2017-01-01 04:00:00"), sdf.parse("2017-01-01 05:00:00")));
        timeSpanList_1.add(new TimeSpan(sdf.parse("2017-01-01 06:00:00"), sdf.parse("2017-01-01 07:00:00")));
        timeSpanList_1.add(new TimeSpan(sdf.parse("2017-01-01 08:00:00"), sdf.parse("2017-01-01 09:00:00")));

        // System.out.println("Merge");
        // List<TimeSpan> timeSpan_add = new ArrayList<TimeSpan>();
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 01:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 01:55:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 02:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 02:05:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 02:55:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 03:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 03:05:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 03:55:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 00:00:00"), sdf.parse("2017-01-01 04:00:00")));
        // for (TimeSpan timeSpan : timeSpan_add) {
        // System.out.println();
        // List<TimeSpan> timeSpanList = DateUtil.Instance().Clone(timeSpanList_1);
        // System.out.println(DateUtil.Instance().TimeSpanList2String(timeSpanList));
        // System.out.println(DateUtil.Instance().TimeSpan2String(timeSpan));
        // List<TimeSpan> result = DateUtil.Instance().Merge(timeSpanList, timeSpan.timefrom, timeSpan.timeto, "5min");
        // System.out.println(DateUtil.Instance().TimeSpanList2String(timeSpanList));
        // System.out.println(DateUtil.Instance().TimeSpanList2String(result));
        // }

        // System.out.println("MergeTo");
        // List<List<TimeSpan>> timeSpanList_add = new ArrayList<List<TimeSpan>>();
        // List<StepSpan> step_span_add = new ArrayList<StepSpan>();
        // List<TimeSpan> ts_add = new ArrayList<TimeSpan>();
        // ts_add.add(new TimeSpan(sdf.parse("2017-01-01 03:10:00"), sdf.parse("2017-01-01 03:50:00")));
        // timeSpanList_add.add(ts_add);
        // step_span_add.add(new StepSpan(0, 0));
        // ts_add = new ArrayList<TimeSpan>();
        // ts_add.add(new TimeSpan(sdf.parse("2017-01-01 03:10:00"), sdf.parse("2017-01-01 03:50:00")));
        // timeSpanList_add.add(ts_add);
        // step_span_add.add(new StepSpan(0, 1));
        // ts_add = new ArrayList<TimeSpan>();
        // ts_add.add(new TimeSpan(sdf.parse("2017-01-01 03:10:00"), sdf.parse("2017-01-01 03:50:00")));
        // timeSpanList_add.add(ts_add);
        // step_span_add.add(new StepSpan(-1, 0));
        // ts_add = new ArrayList<TimeSpan>();
        // ts_add.add(new TimeSpan(sdf.parse("2017-01-01 03:10:00"), sdf.parse("2017-01-01 03:50:00")));
        // timeSpanList_add.add(ts_add);
        // step_span_add.add(new StepSpan(-1, 1));
        // for (int i = 0; i < timeSpanList_add.size(); i++) {
        // System.out.println();
        // List<TimeSpan> tsList = timeSpanList_add.get(i);
        // StepSpan step_span = step_span_add.get(i);
        // List<TimeSpan> timeSpanList = DateUtil.Instance().Clone(timeSpanList_1);
        // System.out.println(DateUtil.Instance().TimeSpanList2String(timeSpanList));
        // System.out.println(DateUtil.Instance().TimeSpanList2String(tsList));
        // System.out.println(DateUtil.Instance().StepSpan2String(step_span));
        // DateUtil.Instance().MergeTo(tsList, "5min", step_span, timeSpanList);
        // System.out.println(DateUtil.Instance().TimeSpanList2String(timeSpanList));
        // }

        // System.out.println("Limit");
        // List<TimeSpan> timeSpan_add = new ArrayList<TimeSpan>();
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 01:00:00"), sdf.parse("2017-01-01 10:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 01:00:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:00:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:55:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 03:00:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 03:05:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 03:55:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 04:00:00"), sdf.parse("2017-01-01 09:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 08:55:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 08:05:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 08:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 07:55:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 07:05:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 07:00:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 06:55:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 06:05:00")));
        // timeSpan_add.add(new TimeSpan(sdf.parse("2017-01-01 02:05:00"), sdf.parse("2017-01-01 06:00:00")));
        // for (TimeSpan timeSpan : timeSpan_add) {
        // System.out.println();
        // List<TimeSpan> timeSpanList = DateUtil.Instance().Clone(timeSpanList_1);
        // System.out.println(DateUtil.Instance().TimeSpanList2String(timeSpanList));
        // System.out.println(DateUtil.Instance().TimeSpan2String(timeSpan));
        // DateUtil.Instance().Limit(timeSpanList, timeSpan.timefrom, timeSpan.timeto);
        // System.out.println(DateUtil.Instance().TimeSpanList2String(timeSpanList));
        // }
    }

    public void ConvertAndMergeTo(List<TimeSpan> timeSpanList, StepSpan step_span, String time_period, String type, List<TimeSpan> result) {
        if (timeSpanList == null) {
            return;
        }
        if (step_span == null) {
            step_span = new StepSpan(0, 0);
        }
        for (TimeSpan timeSpan : timeSpanList) {
            TimeSpan timeSpanInner = this.Convert(timeSpan, time_period, type);
            if (timeSpanInner != null) {
                this.Merge(result, this.GetDate_offset(timeSpanInner.timefrom, time_period, -step_span.forward),
                        this.GetDate_offset(timeSpanInner.timeto, time_period, -step_span.backward), time_period);
            }
        }
    }

    public void ConvertAndMergeTo(List<TimeSpan> timeSpanList, String time_period, String type, List<TimeSpan> result) {
        if (timeSpanList == null) {
            return;
        }
        for (TimeSpan timeSpan : timeSpanList) {
            TimeSpan timeSpanInner = this.Convert(timeSpan, time_period, type);
            if (timeSpanInner != null) {
                this.Merge(result, timeSpanInner.timefrom, timeSpanInner.timeto, time_period);
            }
        }
    }

    public TimeSpan Convert(TimeSpan timeSpan, String time_period, String type) {
        Date timefrom;
        Date timeto;
        if ("near".equals(type)) {
            timefrom = this.get_ceiling(timeSpan.timefrom, time_period);
            timeto = this.get_floor(timeSpan.timeto, time_period);
        } else {
            timefrom = this.get_floor(timeSpan.timefrom, time_period);
            timeto = this.get_floor(timeSpan.timeto, time_period);
        }
        if (timefrom.compareTo(timeto) > 0) {
            return null;
        } else {
            return new TimeSpan(timefrom, timeto);
        }
    }

    public int compare(String time_period_1, String time_period_2) {
        Long mill_1 = this.get_about(time_period_1);
        Long mill_2 = this.get_about(time_period_2);
        return mill_1.compareTo(mill_2);
    }

    public long get_about(String time_period) {
        long result = 0L;
        if ("1min".equals(time_period)) {
            result = 1000L * 60;
        } else if ("5min".equals(time_period)) {
            result = 1000L * 60 * 5;
        } else if ("10min".equals(time_period)) {
            result = 1000L * 60 * 10;
        } else if ("15min".equals(time_period)) {
            result = 1000L * 60 * 15;
        } else if ("1h".equals(time_period)) {
            result = 1000L * 60 * 60;
        } else if ("1d".equals(time_period)) {
            result = 1000L * 60 * 60 * 24;
        } else if ("1m".equals(time_period)) {
            result = 1000L * 60 * 60 * 24 * 30;
        } else if ("1y".equals(time_period)) {
            result = 1000L * 60 * 60 * 24 * 365;
        }
        return result;
    }

    public Date get_floor(Date time, String time_period) {
        Date result = null;
        if ("1min".equals(time_period)) {
            long milliseconds_to = 1000L * 60;
            result = new Date(time.getTime() / milliseconds_to * milliseconds_to);
        } else if ("5min".equals(time_period)) {
            long milliseconds_to = 1000L * 60 * 5;
            result = new Date(time.getTime() / milliseconds_to * milliseconds_to);
        } else if ("10min".equals(time_period)) {
            long milliseconds_to = 1000L * 60 * 10;
            result = new Date(time.getTime() / milliseconds_to * milliseconds_to);
        } else if ("15min".equals(time_period)) {
            long milliseconds_to = 1000L * 60 * 15;
            result = new Date(time.getTime() / milliseconds_to * milliseconds_to);
        } else if ("1h".equals(time_period)) {
            long milliseconds_to = 1000L * 60 * 60;
            result = new Date(time.getTime() / milliseconds_to * milliseconds_to);
        } else if ("1d".equals(time_period)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(time);
            calendar.set(Calendar.HOUR_OF_DAY, 0);
            calendar.set(Calendar.MINUTE, 0);
            calendar.set(Calendar.SECOND, 0);
            calendar.set(Calendar.MILLISECOND, 0);
            result = calendar.getTime();
        } else if ("1m".equals(time_period)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(time);
            calendar.set(Calendar.DAY_OF_MONTH, 1);
            calendar.set(Calendar.HOUR_OF_DAY, 0);
            calendar.set(Calendar.MINUTE, 0);
            calendar.set(Calendar.SECOND, 0);
            calendar.set(Calendar.MILLISECOND, 0);
            result = calendar.getTime();
        } else if ("1y".equals(time_period)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(time);
            calendar.set(Calendar.MONTH, 0);
            calendar.set(Calendar.DAY_OF_MONTH, 1);
            calendar.set(Calendar.HOUR_OF_DAY, 0);
            calendar.set(Calendar.MINUTE, 0);
            calendar.set(Calendar.SECOND, 0);
            calendar.set(Calendar.MILLISECOND, 0);
            result = calendar.getTime();
        }
        return result;
    }

    public Date get_ceiling(Date time, String time_period) {
        Date floor = this.get_floor(time, time_period);
        if (floor.compareTo(time) == 0) {
            return floor;
        } else {
            return this.GetDate_offset(floor, time_period, 1);
        }
    }

    public void Limit(List<TimeSpan> timeSpanList, Date timefrom, Date timeto) {
        if (timeSpanList.size() == 0) {
            return;
        }

        // index取值[0~2n]
        int timefrom_index = 0;
        int timeto_index = 0;
        for (int i = 0; i < timeSpanList.size(); i++) {
            TimeSpan timeSpanInner = timeSpanList.get(i);

            if (timefrom.compareTo(timeSpanInner.timeto) <= 0) {
                if (timefrom.compareTo(timeSpanInner.timefrom) >= 0) {
                    timefrom_index = i * 2 + 1;
                }
            } else {
                timefrom_index = i * 2 + 2;
            }

            if (timeto.compareTo(timeSpanInner.timeto) <= 0) {
                if (timeto.compareTo(timeSpanInner.timefrom) >= 0) {
                    timeto_index = i * 2 + 1;
                }
            } else {
                timeto_index = i * 2 + 2;
            }
        }

        int index_del_left = timefrom_index / 2;
        for (int i = index_del_left - 1; i >= 0; i--) {
            timeSpanList.remove(i);
        }

        int index_del_right = (timeto_index + 1) / 2;
        for (int i = timeSpanList.size() - 1; i >= index_del_right; i--) {
            timeSpanList.remove(i);
        }

        if (timeSpanList.size() == 0) {
            return;
        }

        TimeSpan timeSpan_first = timeSpanList.get(0);
        TimeSpan timeSpan_last = timeSpanList.get(timeSpanList.size() - 1);

        if (timeSpan_first.timefrom.compareTo(timefrom) < 0) {
            timeSpan_first.timefrom = timefrom;
        }
        if (timeSpan_last.timeto.compareTo(timeto) > 0) {
            timeSpan_last.timeto = timeto;
        }
    }

    public void MergeTo(List<TimeSpan> timeSpanList, String time_period, StepSpan step_span, List<TimeSpan> result) {
        if (step_span == null) {
            step_span = new StepSpan(0, 0);
        }
        for (TimeSpan timeSpan : timeSpanList) {
            this.Merge(result, this.GetDate_offset(timeSpan.timefrom, time_period, step_span.backward),
                    this.GetDate_offset(timeSpan.timeto, time_period, step_span.forward), time_period);
        }
    }

    public List<TimeSpan> Merge(List<TimeSpan> timeSpanList, Date timefrom, Date timeto, String time_period) {
        List<TimeSpan> result = new ArrayList<TimeSpan>();
        if (timeSpanList.size() == 0) {
            timeSpanList.add(new TimeSpan(timefrom, timeto));
            result.add(new TimeSpan(timefrom, timeto));
            return result;
        }

        // index取值[0~2n]
        int timefrom_index = 0;
        int timeto_index = 0;
        for (int i = 0; i < timeSpanList.size(); i++) {
            TimeSpan timeSpanInner = timeSpanList.get(i);

            if (timefrom.compareTo(timeSpanInner.timeto) <= 0) {
                if (timefrom.compareTo(timeSpanInner.timefrom) >= 0) {
                    timefrom_index = i * 2 + 1;
                }
            } else {
                timefrom_index = i * 2 + 2;
            }

            if (timeto.compareTo(timeSpanInner.timeto) <= 0) {
                if (timeto.compareTo(timeSpanInner.timefrom) >= 0) {
                    timeto_index = i * 2 + 1;
                }
            } else {
                timeto_index = i * 2 + 2;
            }
        }

        if (timefrom_index == timeto_index) {// from和to落在同一区间
            if (timefrom_index % 2 == 0) {// 在缝中
                TimeSpan timeSpan_left = null;
                TimeSpan timeSpan_right = null;
                Date time_close_left = null;
                Date time_close_right = null;

                int index_right = timefrom_index / 2;
                int index_left = index_right - 1;
                if (index_left >= 0) {
                    timeSpan_left = timeSpanList.get(index_left);
                    time_close_left = this.GetDate_offset(timeSpan_left.timeto, time_period, 1);
                }
                if (index_right < timeSpanList.size()) {
                    timeSpan_right = timeSpanList.get(index_right);
                    time_close_right = this.GetDate_offset(timeSpan_right.timefrom, time_period, -1);
                }
                if (time_close_left != null && time_close_left.compareTo(timefrom) == 0) {
                    if (time_close_right != null && time_close_right.compareTo(timeto) == 0) {// 两边挨着
                        timeSpan_left.timeto = timeSpan_right.timeto;
                        timeSpanList.remove(timeSpan_right);
                    } else {// 左边挨着
                        timeSpan_left.timeto = timeto;
                    }
                } else {
                    if (time_close_right != null && time_close_right.compareTo(timeto) == 0) {// 右边挨着
                        timeSpan_right.timefrom = timefrom;
                    } else {// 两边都不挨着
                        timeSpanList.add(index_right, new TimeSpan(timefrom, timeto));
                    }
                }
                result.add(new TimeSpan(timefrom, timeto));
                return result;
            } else {// 属于已有区间
                return result;
            }
        } else {// from和to没落在同一区间
            List<TimeSpan> result_left = new ArrayList<TimeSpan>();
            List<TimeSpan> result_right = new ArrayList<TimeSpan>();

            int index_from_right = timefrom_index / 2;
            int index_to_left = (timeto_index - 1) / 2;

            int index_merge_from = index_from_right;
            int index_merge_to = index_to_left;

            TimeSpan timeSpan_from_right = timeSpanList.get(index_from_right);
            TimeSpan timeSpan_to_left = timeSpanList.get(index_to_left);
            Date time_close_from_right = this.GetDate_offset(timeSpan_from_right.timefrom, time_period, -1);
            Date time_close_to_left = this.GetDate_offset(timeSpan_to_left.timeto, time_period, 1);
            if (timefrom_index % 2 == 0) {// 在缝中
                TimeSpan timeSpan_left = null;
                Date time_close_left = null;

                int index_left = index_from_right - 1;
                if (index_left >= 0) {
                    timeSpan_left = timeSpanList.get(index_left);
                    time_close_left = this.GetDate_offset(timeSpan_left.timeto, time_period, 1);
                }
                if (time_close_left != null && time_close_left.compareTo(timefrom) == 0) {
                    index_merge_from = index_left;
                } else {
                    timeSpan_from_right.timefrom = timefrom;
                }
                result_left.add(new TimeSpan(timefrom, time_close_from_right));
            } else {// 属于已有区间
            }

            if (timeto_index % 2 == 0) {// 在缝中
                TimeSpan timeSpan_right = null;
                Date time_close_right = null;

                int index_right = index_to_left + 1;
                if (index_right < timeSpanList.size()) {
                    timeSpan_right = timeSpanList.get(index_right);
                    time_close_right = this.GetDate_offset(timeSpan_right.timefrom, time_period, -1);
                }
                if (time_close_right != null && time_close_right.compareTo(timeto) == 0) {
                    index_merge_to = index_right;
                } else {
                    timeSpan_to_left.timeto = timeto;
                }
                result_right.add(new TimeSpan(time_close_to_left, timeto));
            } else {// 属于已有区间
            }

            result.addAll(result_left);
            for (int i = index_from_right; i < index_to_left; i++) {
                TimeSpan timeSpan0 = timeSpanList.get(i);
                TimeSpan timeSpan1 = timeSpanList.get(i + 1);
                Date time0 = this.GetDate_offset(timeSpan0.timeto, time_period, 1);
                Date time1 = this.GetDate_offset(timeSpan1.timefrom, time_period, -1);
                result.add(new TimeSpan(time0, time1));
            }
            result.addAll(result_right);

            TimeSpan timeSpan_merge_from = timeSpanList.get(index_merge_from);
            TimeSpan timeSpan_merge_to = timeSpanList.get(index_merge_to);
            timeSpan_merge_from.timeto = timeSpan_merge_to.timeto;
            for (int i = index_merge_to; i > index_merge_from; i--) {
                timeSpanList.remove(i);
            }

            return result;
        }
    }

    public Date GetDate_offset(Date currentDate, String time_period, int count) {
        Date nextDate = null;
        if ("1min".equals(time_period)) {
            nextDate = new Date(currentDate.getTime() + 1000L * 60 * count);
        } else if ("5min".equals(time_period)) {
            nextDate = new Date(currentDate.getTime() + 1000L * 60 * 5 * count);
        } else if ("10min".equals(time_period)) {
            nextDate = new Date(currentDate.getTime() + 1000L * 60 * 10 * count);
        } else if ("15min".equals(time_period)) {
            nextDate = new Date(currentDate.getTime() + 1000L * 60 * 15 * count);
        } else if ("1h".equals(time_period)) {
            nextDate = new Date(currentDate.getTime() + 1000L * 60 * 60 * count);
        } else if ("1d".equals(time_period)) {
            nextDate = new Date(currentDate.getTime() + 1000L * 60 * 60 * 24 * count);
        } else if ("1m".equals(time_period)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(currentDate);
            calendar.add(Calendar.MONTH, count);
            nextDate = calendar.getTime();
        } else if ("1y".equals(time_period)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(currentDate);
            calendar.add(Calendar.YEAR, count);
            nextDate = calendar.getTime();
        }
        return nextDate;
    }

    public List<TimeSpan> Clone(List<TimeSpan> timeSpanList) {
        List<TimeSpan> result = new ArrayList<TimeSpan>();
        for (TimeSpan ts : timeSpanList) {
            TimeSpan timeSpan = new TimeSpan(ts.timefrom, ts.timeto);
            result.add(timeSpan);
        }
        return result;
    }

    public String TimeSpanList2String(List<TimeSpan> timeSpanList) {
        StringBuffer sb = new StringBuffer();
        for (TimeSpan timeSpan : timeSpanList) {
            if (sb.length() > 0) {
                sb.append("    ");
            }
            sb.append(this.TimeSpan2String(timeSpan));
        }
        return sb.toString();
    }

    public String TimeSpan2String(TimeSpan span) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(span.timefrom) + " ~ " + sdf.format(span.timeto);
    }

    public String StepSpan2String(StepSpan span) {
        return span.backward + " ~ " + span.forward;
    }
}
