package com.sagacloud.util.compute_engine.util;

import com.sagacloud.util.compute_engine.core.CoreInput;
import com.sagacloud.util.compute_engine.core.CoreInstance;
import com.sagacloud.util.compute_engine.core.CoreOutput;

public class SurveyUtil {

    public static CoreInstance Convert_max(CoreInstance instance) throws Exception {
        CoreInstance result = new CoreInstance();
        result.object_sign = instance.object_sign;
        result.instance_name = instance.instance_name;
        String instance_name_ori = instance.instance_name.substring(0, instance.instance_name.length() - 4);

        for (CoreOutput output_tmp : instance.outputList) {
            if ("tenantfee".equals(output_tmp.dao_type)) {
                continue;
            }

            CoreInput input = new CoreInput();
            input.input_sign = output_tmp.output_sign;
            input.time_period = output_tmp.time_period;
            input.data_class = output_tmp.data_class;
            input.dao_type = output_tmp.dao_type;
            input.dao_key = output_tmp.dao_key;
            input.source_object_sign = instance.object_sign;
            input.source_instance_name = instance_name_ori;
            input.source_output_sign = output_tmp.output_sign;
            result.inputList.add(input);

            CoreOutput output = new CoreOutput();
            output.output_sign = output_tmp.output_sign;
            output.time_begin = output_tmp.time_begin;
            output.time_end = output_tmp.time_end;
            output.data_class = output_tmp.data_class;
            output.dao_type = output_tmp.dao_type + "_max";
            output.dao_key = output_tmp.dao_key;
            output.need_all_var_data = false;
            output.time_period_intialized = true;
            output.time_period = output_tmp.time_period;
            output.mode = "expression";
            output.expression = output_tmp.output_sign;
            result.outputList.add(output);
        }

        return result;
    }
}
