package test;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import com.zillion.database.agent.ZillionAgent;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;

@Slf4j
public class delete_209_Thread extends Thread {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

    ZillionAgent agent;
    String database_name;

    public delete_209_Thread(String database_name) {

        this.database_name = database_name;
    }

    @Override
    public void run() {
        while (true) {
            JSONObject item = delete_209.Pop();
            if (item == null) {
                break;
            }

            String building = (String) item.get("building");
            String meter = (String) item.get("meter");
            Long funcid = (Long) item.get("funcid");
            try {
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    QueryUtil.delete(database_name, "fjd_0_metercomputetime", CriteriaInner);
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    CriteriaInner.put("time_period", "10min");
                    JSONObject rangeInner = new JSONObject();
                    rangeInner.put("$gte", "20171101000000");
                    rangeInner.put("$lt", "20180201000000");
                    CriteriaInner.put("data_time", rangeInner);
                    long Count = QueryUtil.delete(database_name, "fjd_0_near", CriteriaInner);
                    log.warn("fjd_0_near" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + Count);
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    CriteriaInner.put("time_period", "15min");
                    JSONObject rangeInner = new JSONObject();
                    rangeInner.put("$gte", "20171101000000");
                    rangeInner.put("$lt", "20180201000000");
                    CriteriaInner.put("data_time", rangeInner);
                    long Count = QueryUtil.delete(database_name, "fjd_0_near", CriteriaInner);
                    log.warn("fjd_0_near" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + Count);
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    CriteriaInner.put("time_period", "1h");
                    JSONObject rangeInner = new JSONObject();
                    rangeInner.put("$gte", "20171101000000");
                    rangeInner.put("$lt", "20180201000000");
                    CriteriaInner.put("data_time", rangeInner);
                    long Count = QueryUtil.delete(database_name, "fjd_0_near", CriteriaInner);
                    log.warn("fjd_0_near" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + Count);
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    CriteriaInner.put("time_period", "1d");
                    JSONObject rangeInner = new JSONObject();
                    rangeInner.put("$gte", "20171101000000");
                    rangeInner.put("$lt", "20180201000000");
                    CriteriaInner.put("data_time", rangeInner);
                    long Count = QueryUtil.delete(database_name, "fjd_0_near", CriteriaInner);
                    log.warn("fjd_0_near" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + Count);
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    long Count = QueryUtil.delete(database_name, "fjd_0_computedetail", CriteriaInner);
                    log.warn("fjd_0_computedetail" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + Count);
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    QueryUtil.delete(database_name, "dy_pointlist", CriteriaInner);
                }
            } catch (Exception e) {
                log.error(e.getMessage(),e);
            }
        }
    }
}
