package com.sagacloud.extend.customfunction;

import com.sagacloud.util.compute_engine.core.AnnotationDescription;
import com.sagacloud.util.compute_engine.core.ICustomFunction;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@AnnotationDescription(value = "custom_function")
public class ImplCustomFunction_f3 implements ICustomFunction {
    @Override
    public String GetName() {
        return "f3";
    }

    public List<String> GetParamList() {
        List<String> result = new ArrayList<String>();
        result.add("a");
        result.add("b");
        result.add("c");
        return result;
    }

    @Override
    public double Compute(Map<String, Double> inputMap) {
        double a = inputMap.get("a");
        double b = inputMap.get("b");
        double c = inputMap.get("c");
        return a > b ? c : 250.0;
    }
}
