package com.sagacloud.util.compute_engine.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@Slf4j
@XmlRootElement(name = "Entity_tenant_energy")
public class Entity_tenant_energy {
    public Map<String, Entity_tenant_energy_meter> meterMap = new HashMap<String, Entity_tenant_energy_meter>();
    public List<Entity_tenant_energy_price> priceList = new ArrayList<Entity_tenant_energy_price>();
    String building;
    String sign;
    String energy_type;
    String price_type;
    Boolean soft_enable;
    Double soft_initial_yuer;

    public Entity_tenant_energy() {

    }

    public Entity_tenant_energy(String str) {
        try {
            JSONObject json = (JSONObject) JSON.parse(str);
            FastJsonUtil.Set_JavaObject(json, this);
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
    }

    public String getBuilding() {
        return building;
    }

    public void setBuilding(String building) {
        this.building = building;
    }

    public String getSign() {
        return sign;
    }

    public void setSign(String sign) {
        this.sign = sign;
    }

    public String getEnergy_type() {
        return energy_type;
    }

    public void setEnergy_type(String energy_type) {
        this.energy_type = energy_type;
    }

    public String getPrice_type() {
        return price_type;
    }

    public void setPrice_type(String price_type) {
        this.price_type = price_type;
    }

    public Boolean getSoft_enable() {
        return soft_enable;
    }

    public void setSoft_enable(Boolean soft_enable) {
        this.soft_enable = soft_enable;
    }

    public Double getSoft_initial_yuer() {
        return soft_initial_yuer;
    }

    public void setSoft_initial_yuer(Double soft_initial_yuer) {
        this.soft_initial_yuer = soft_initial_yuer;
    }
}
