package com.sagacloud.util.compute_engine.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "Entity_tenant_energy_price")
public class Entity_tenant_energy_price {
    public Object priceObject;
    String building;
    String sign;
    String energy_type;
    String valid_time_from;
    String valid_time_to;
    String price_content;

    public Entity_tenant_energy_price() {

    }

    public Entity_tenant_energy_price(String str) {
        try {
            JSONObject json = (JSONObject) JSON.parse(str);
            FastJsonUtil.Set_JavaObject(json, this);
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
    }

    public String getBuilding() {
        return building;
    }

    public void setBuilding(String building) {
        this.building = building;
    }

    public String getSign() {
        return sign;
    }

    public void setSign(String sign) {
        this.sign = sign;
    }

    public String getEnergy_type() {
        return energy_type;
    }

    public void setEnergy_type(String energy_type) {
        this.energy_type = energy_type;
    }

    public String getValid_time_from() {
        return valid_time_from;
    }

    public void setValid_time_from(String valid_time_from) {
        this.valid_time_from = valid_time_from;
    }

    public String getValid_time_to() {
        return valid_time_to;
    }

    public void setValid_time_to(String valid_time_to) {
        this.valid_time_to = valid_time_to;
    }

    public String getPrice_content() {
        return price_content;
    }

    public void setPrice_content(String price_content) {
        this.price_content = price_content;
    }
}
