package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.QueryUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

@SuppressWarnings("unused")
public class Check_servicedata {
    public static String time_from = "20171101000000";
    public static String time_to = "20171201000000";
    static int thread_count = 1;
    static List<JSONObject> itemList = new ArrayList<JSONObject>();
    static Random rand = new Random();

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        String database_name = ConstantCE.database_name;

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", "1101070037");
        JSONArray resultContent = QueryUtil.select(database_name, "dy_pointlist", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            Long funcid = (Long) item.get("funcid");

            if (funcid != 0) {
                continue;
            }

            itemList.add(item);
        }

        List<Check_servicedata_Thread> threadList = new ArrayList<Check_servicedata_Thread>();
        for (int index = 0; index < thread_count; index++) {
            Check_servicedata_Thread thread = new Check_servicedata_Thread(database_name);
            thread.start();
            threadList.add(thread);
        }

        while (true) {
            Thread.sleep(1L);

            boolean all_finish = true;
            for (Check_servicedata_Thread thread : threadList) {
                if (thread.isAlive()) {
                    all_finish = false;
                    break;
                }
            }
            if (all_finish) {
                break;
            }
        }


        System.out.println();
    }

    public static synchronized JSONObject Pop() {
        JSONObject item = null;
        if (itemList.size() > 0) {
            // item = itemList.remove(rand.nextInt(itemList.size()));
            item = itemList.remove(0);
            String building = (String) item.get("building");
            String meter = (String) item.get("meter");
            Long funcid = (Long) item.get("funcid");
            // log.warn(building + "\t" + meter + "\t" + funcid + "\t" + itemList.size());
        }
        return item;
    }
}
