package test;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.QueryUtil;

public class Clear_building {
    public static final int thread_count = 1;

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        // String[] buildings = { "1101010001", "1101080001", "1101080002" };
        // String[] compute_times = { "20171101000000", "20171101000000", "20171101000000" };
        String[] buildings = {"1101080001"};
        String[] compute_times = {"20171101000000"};
        for (int i = 0; i < buildings.length; i++) {
            String building = buildings[i];
            String compute_time = compute_times[i];
            {
                JSONObject Criteria = new JSONObject();
                Criteria.put("object_sign", building);
                QueryUtil.delete(ConstantCE.database_name, "ce_computeinputdetail", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "ce_computeinputlog", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "ce_computelog", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "ce_computeoutputdetail", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "ce_curround", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "ce_preroundindex", Criteria);
            }
            {
                JSONObject Criteria = new JSONObject();
                Criteria.put("building", building);
                QueryUtil.delete(ConstantCE.database_name, "fjd_0_computedetail", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "fjd_0_computelog", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "fjd_0_near", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "fjd_0_rate", Criteria);
                QueryUtil.delete(ConstantCE.database_name, "fjd_statinst", Criteria);
            }
            {
                JSONObject Criteria = new JSONObject();
                Criteria.put("building", building);
                QueryUtil.delete(ConstantCE.database_name, "fjd_0_metercomputetime", Criteria);
            }
            {
                JSONObject Criteria = new JSONObject();
                Criteria.put("building", building);
                JSONObject Set = new JSONObject();
                Set.put("compute_time", compute_time);
                QueryUtil.update(ConstantCE.database_name, "fjd_0_buildingcomputetime", Criteria, Set);
            }
        }


    }

}
