package test;

import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.core.CoreComputeUtil;
import com.sagacloud.util.compute_engine.core.CoreComputeUtilUtil;
import com.sagacloud.util.compute_engine.core.CoreInstance;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instance;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.InstanceUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class Test_instance {

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        String object_sign = "1101060003-001";
        String instance_name = "EMS";
        Entity_ci_instance Entity_ci_instance = InstanceUtil.Get(ConstantCE.database_name, object_sign, instance_name);
        CoreInstance instance = CoreInstance.Convert(Entity_ci_instance);
        CoreComputeUtil.Refresh(instance);
        CoreComputeUtilUtil.BuildNetwork(instance);

        log.warn("");
    }

}
