package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

@Slf4j
public class delete_209 {
    static int thread_count = 10;
    static List<JSONObject> itemList = new ArrayList<JSONObject>();
    static Random rand = new Random();

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        String database_name = ConstantCE.database_name;

        JSONObject Criteria = new JSONObject();
        JSONArray resultContent = QueryUtil.select(database_name, "dy_pointlist", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            Long funcid = (Long) item.get("funcid");

            if (funcid != 209) {
                continue;
            }

            itemList.add(item);
        }

        List<delete_209_Thread> threadList = new ArrayList<delete_209_Thread>();
        for (int index = 0; index < thread_count; index++) {
            delete_209_Thread thread = new delete_209_Thread(database_name);
            thread.start();
            threadList.add(thread);
        }

        while (true) {
            Thread.sleep(1L);

            boolean all_finish = true;
            for (delete_209_Thread thread : threadList) {
                if (thread.isAlive()) {
                    all_finish = false;
                    break;
                }
            }
            if (all_finish) {
                break;
            }
        }


        System.out.println();
    }

    public static synchronized JSONObject Pop() {
        JSONObject item = null;
        if (itemList.size() > 0) {
            item = itemList.remove(rand.nextInt(itemList.size()));
            String building = (String) item.get("building");
            String meter = (String) item.get("meter");
            Long funcid = (Long) item.get("funcid");
            log.warn(building + "\t" + meter + "\t" + funcid + "\t" + itemList.size());
        }
        return item;
    }
}
